var Macarona = Macarona || {};
var MacaronaIds = MacaronaIds || {};

Macarona.extend = function (mainArray, otherArray) {
  otherArray.forEach(function (i) {
    mainArray.push(i);
  }, this);
};

// Decides where to add lucille next when recruiting
Macarona.getLucillePosition = function () {
  let shittyFollowerArray = $gamePlayer._followers._data;
  for (i = 0; i < shittyFollowerArray.length; i++) {
    if (!shittyFollowerArray[i]._characterName && !shittyFollowerArray[i]._graphicsData) {
      return i;
    }
  }
};

// Handles the new anti-softlock
Game_Character.prototype.timerCheck = function() {
  if ($gameTemp._lucilleTimer > 4) {
    if ($gameSwitches._lucilleKidnapped) {
      this.sswitch("C",true); 
      $gameMap.refresh()
    } else {
      this.sswitch("B",true); 
    }
    return;
  }
  let dis = Math.abs(this.deltaXFrom($gamePlayer.x));
  dis += Math.abs(this.deltaYFrom($gamePlayer.y));
  if (dis > 4) {
    this.sswitch("A",false)
    this.setCustomFrameXY(null, null);
    return;
  };
};

/**
 * Dictionary of ids. Instantiate as 0, actual number is set on database load.
 * In other note tags you can then get ids like MacaronaIds.skill["Lucille Heal"]
 */
MacaronaIds.skill = {
    "Lucille Heal": 0,
    "Lucille Heal (Hard)": 0,
    "Lucille Heal (Challenge)": 0,
    "Starting Shot": 0,
}

// These skills are copied from the json
const SKILL_LUCILLE_A = {"id":3005,"animationId":0,"damage":{"critical":true,"elementId":11,"formula":"400 + a.atk * 12 - b.def; a._healCount = 0;","type":0,"variance":20},"description":"","effects":[],"hitType":0,"iconIndex":0,"message1":"","message2":"","mpCost":0,"name":"LUCILLE ACTION","note":"\n<setup action>\neval: BattleManager._logWindow.addText(\"LUCILLE steps in to help!\")\neval: $gameTemp._oldDisplayLayer = BattleManager._pictureDisplayLayer;\neval: BattleManager.setPictureDisplayLayer('front');\neval: $gameScreen.showPicture(55, \"lucille_interruption\", 0, 0, 480, 100, 100, 255, 0);\nSE: lucille_popup, 90, 100, 0\neval: $gameScreen.movePicture(55, 0, 0, 0, 100, 100, 255, 0, 45);\nwait: 60\nanimation 216: targets\neval: $gameScreen.movePicture(55, 0, 0, 0, 100, 100, 0, 0, 45);\nwait: 45\neval: $gameScreen.erasePicture(55);\neval: $gameTemp._lucilleActionArray = [\"hp_heal\",\"mp_heal\",\"buff\",\"charge\"];\nif $gameTemp._usedCharge\n eval: $gameTemp._lucilleActionArray.pop();\n eval: $gameTemp._usedCharge = false;\nend\nif Macarona.needHpHeal()\n eval: $gameTemp._lucilleActionArray = [\"hp_heal\"];\nend\nif Macarona.needMpHeal()\n eval: $gameTemp._lucilleActionArray = [\"mp_heal\"];\nend\neval: $gameTemp._lucilleActionChoice = $gameTemp._lucilleActionArray[Math.floor(Math.random() * $gameTemp._lucilleActionArray.length)];\n</setup action>\n\n<whole action>\nif $gameTemp._lucilleActionChoice === \"hp_heal\"\n eval: BattleManager._logWindow.addText(\"Everyone's HEART was healed!\")\nend\nif $gameTemp._lucilleActionChoice === \"mp_heal\"\n eval: BattleManager._logWindow.addText(\"Everyone's JUICE was healed!\")\nend\nif $gameTemp._lucilleActionChoice === \"buff\"\n eval: BattleManager._logWindow.addText(\"Everyone's STATS went up!\")\nend\nif $gameTemp._lucilleActionChoice === \"charge\"\n eval: BattleManager._logWindow.addText(\"Everyone flexed and felt their best!\")\nend\n</whole action>\n\n<target action>\nif $gameTemp._lucilleActionChoice === \"hp_heal\"\n animation 212: target\n HP +90%: target\n MP +10%: target\n wait for animation\nend\nif $gameTemp._lucilleActionChoice === \"mp_heal\"\n animation 213: target\n MP +90%: target\n HP +10%: target\n wait for animation\nend\nif $gameTemp._lucilleActionChoice === \"buff\"\n animation 214: target\n eval: target.megatenSlop(\"atk\", 2);\n eval: target.megatenSlop(\"def\", 1);\n eval: target.megatenSlop(\"spd\", 1);\n wait for animation\nend\nif $gameTemp._lucilleActionChoice === \"charge\"\n animation 214: target\n add state 33: target\n wait for animation\n eval: $gameTemp._usedCharge = true;\nend\n</target action>","occasion":1,"repeats":1,"requiredWtypeId1":0,"requiredWtypeId2":0,"scope":8,"speed":0,"stypeId":0,"successRate":100,"tpCost":0,"tpGain":0}

const SKILL_LUCILLE_HARD = {"id":3003,"animationId":0,"damage":{"critical":true,"elementId":11,"formula":"400 + a.atk * 12 - b.def; a._healCount = 0;","type":0,"variance":20},"description":"","effects":[],"hitType":0,"iconIndex":0,"message1":"","message2":"","mpCost":0,"name":"LUCILLE ACTION (HARD)","note":"\n<setup action>\neval: BattleManager._logWindow.addText(\"LUCILLE steps in to help!\")\neval: $gameTemp._oldDisplayLayer = BattleManager._pictureDisplayLayer;\neval: BattleManager.setPictureDisplayLayer('front');\neval: $gameScreen.showPicture(55, \"lucille_interruption\", 0, 0, 480, 100, 100, 255, 0);\nSE: lucille_popup, 90, 100, 0\neval: $gameScreen.movePicture(55, 0, 0, 0, 100, 100, 255, 0, 45);\nwait: 60\nanimation 216: targets\neval: $gameScreen.movePicture(55, 0, 0, 0, 100, 100, 0, 0, 45);\nwait: 45\neval: $gameScreen.erasePicture(55);\neval: $gameTemp._lucilleActionArray = [\"hp_heal\",\"mp_heal\",\"buff\"];\nif Macarona.needHpHeal()\n eval: $gameTemp._lucilleActionArray = [\"hp_heal\"];\nend\nif Macarona.needMpHeal()\n eval: $gameTemp._lucilleActionArray = [\"mp_heal\"];\nend\neval: $gameTemp._lucilleActionChoice = $gameTemp._lucilleActionArray[Math.floor(Math.random() * $gameTemp._lucilleActionArray.length)];\n</setup action>\n\n<whole action>\nif $gameTemp._lucilleActionChoice === \"hp_heal\"\n eval: BattleManager._logWindow.addText(\"Everyone's HEART was healed!\")\nend\nif $gameTemp._lucilleActionChoice === \"mp_heal\"\n eval: BattleManager._logWindow.addText(\"Everyone's JUICE was healed!\")\nend\nif $gameTemp._lucilleActionChoice === \"buff\"\n eval: BattleManager._logWindow.addText(\"Everyone's ATTACK went up!\")\nend\n</whole action>\n\n<target action>\nif $gameTemp._lucilleActionChoice === \"hp_heal\"\n animation 212: target\n HP +45%: target\n wait for animation\nend\nif $gameTemp._lucilleActionChoice === \"mp_heal\"\n animation 213: target\n MP +45%: target\n wait for animation\nend\nif $gameTemp._lucilleActionChoice === \"buff\"\n animation 214: target\n eval: target.megatenSlop(\"atk\", 1);\n wait for animation\nend\n</target action>","occasion":1,"repeats":1,"requiredWtypeId1":0,"requiredWtypeId2":0,"scope":8,"speed":0,"stypeId":0,"successRate":100,"tpCost":0,"tpGain":0}

const SKILL_LUCILLE_CHALLENGE = {"id":3002,"animationId":0,"damage":{"critical":true,"elementId":1,"formula":"b.mhp * 0.5","type":1,"variance":20},"description":"","effects":[],"hitType":0,"iconIndex":0,"message1":"","message2":"","mpCost":0,"name":"LUCILLE ACTION (CHALLENGE)","note":"\n<setup action>\neval: BattleManager._logWindow.addText(\"LUCILLE steps in to distract you!\")\neval: $gameTemp._oldDisplayLayer = BattleManager._pictureDisplayLayer;\neval: BattleManager.setPictureDisplayLayer('front');\neval: $gameScreen.showPicture(55, \"lucille_interruption\", 0, 0, 480, 100, 100, 255, 0);\nSE: lucille_popup, 90, 100, 0\neval: $gameScreen.movePicture(55, 0, 0, 0, 100, 100, 255, 0, 45);\nwait: 60\nanimation 148: target\neval: $gameScreen.movePicture(55, 0, 0, 0, 100, 100, 0, 0, 45);\nwait: 45\neval: $gameScreen.erasePicture(55);\neval: $gameTemp._lucilleActionArray = [\"damage\",\"debuff\",\"stun\"];\neval: $gameTemp._lucilleActionChoice = $gameTemp._lucilleActionArray[Math.floor(Math.random() * $gameTemp._lucilleActionArray.length)];\n</setup action>\n\n<target action>\nif $gameTemp._lucilleActionChoice === \"damage\"\n eval: BattleManager._logWindow.addText(`${target.name()} got smacked!`)\n animation 132: target\n wait for animation\n action effect\nend\nif $gameTemp._lucilleActionChoice === \"debuff\"\n eval: BattleManager._logWindow.addText(`${target.name()}'s STATS fell!`)\n animation 215: target\n eval: target.megatenSlop(\"atk\", -1);\n eval: target.megatenSlop(\"def\", -1);\n eval: target.megatenSlop(\"spd\", -1);\n wait for animation\nend\nif $gameTemp._lucilleActionChoice === \"stun\"\n eval: BattleManager._logWindow.addText(`${target.name()} is too distracted to move!`)\n animation 212: target\n add state 25: target\n wait for animation\nend\n</target action>","occasion":1,"repeats":1,"requiredWtypeId1":0,"requiredWtypeId2":0,"scope":7,"speed":0,"stypeId":0,"successRate":100,"tpCost":0,"tpGain":0}

const SKILL_LUCILLE_SHOT = {"id":3004,"animationId":123,"damage":{"critical":true,"elementId":11,"formula":"a.atk * 2 - b.def;","type":1,"variance":20},"description":"","effects":[],"hitType":0,"iconIndex":0,"message1":"","message2":"","mpCost":0,"name":"STARTING SHOT","note":"<Damage Formula>\nif (this._calculatedBaseDmg) {\n  value = this._calculatedBaseDmg;\n} else {\n  // Get the total number of enemies\n  var members = $gameParty.aliveMembers();\n  var groupatk = 0;\n  for (i = 0; i < members.length; i++) {\n    groupatk += members[i].atk;\n  }\n  groupatk = Math.ceil(groupatk / members.length);\n  if (ConfigManager.lucilleDifficulty === 1) {\n    this._calculatedBaseDmg = groupatk * 3 - b.def;\n  } else {\n    this._calculatedBaseDmg = groupatk * 7 - b.def;\n  };\n  value = this._calculatedBaseDmg;\n}\n</Damage Formula>\n\n<setup action>\neval: BattleManager._logWindow.addText(\"LUCILLE aims for a shot!\")\neval: $gameTemp._oldDisplayLayer = BattleManager._pictureDisplayLayer;\neval: BattleManager.setPictureDisplayLayer('top');\neval: $gameScreen.showPicture(55, \"lucille_ultimate1\", 0, 640, 0, 100, 100, 255, 0);\neval: $gameScreen.movePicture(55, 0, 0, 0, 100, 100, 255, 0, 60);\nwait: 75\neval: $gameScreen.showPicture(56, \"lucille_ultimate2\", 0, 0, 0, 100, 100, 255, 0);\nSE: startingshot, 90, 100, 0\nanimation 1: target\neval: $gameScreen.erasePicture(55);\n</setup action>\n\n<target action>\naction animation\naction effect\nwait: 20\neval: $gameScreen.movePicture(56, 0, 0, 0, 100, 100, 0, 0, 45);\nwait: 45\neval: $gameScreen.erasePicture(56);\n</target action>","occasion":1,"repeats":1,"requiredWtypeId1":0,"requiredWtypeId2":0,"scope":1,"speed":0,"stypeId":0,"successRate":100,"tpCost":0,"tpGain":0}

var injectedTroop = {"id":710,"members":[],"name":"lucillesthighs","pages":[{"conditions":{"actorHp":50,"actorId":1,"actorValid":false,"enemyHp":50,"enemyIndex":0,"enemyValid":false,"switchId":3005,"switchValid":false,"turnA":1,"turnB":1,"turnEnding":true,"turnValid":true},"list":[{"code":111,"indent":0,"parameters":[12,"$gameSwitches._lucilleKidnapped"]},{"code":355,"indent":1,"parameters":["$gameTemp._lucilleAbsent = $gameTemp._lucilleAbsent || 0;"]},{"code":355,"indent":1,"parameters":["if (ConfigManager.lucilleDifficulty == 1) {"]},{"code":655,"indent":1,"parameters":["$gameTemp._lucilleSkillRNG = Math.floor(Math.random() * 4);"]},{"code":655,"indent":1,"parameters":["if ($gameTemp._lucilleAbsent > 2) {"]},{"code":655,"indent":1,"parameters":["$gameTemp._lucilleSkillRNG = 1;"]},{"code":655,"indent":1,"parameters":["$gameTemp._lucilleAbsent = 0;"]},{"code":655,"indent":1,"parameters":["};"]},{"code":655,"indent":1,"parameters":["} else {"]},{"code":655,"indent":1,"parameters":["$gameTemp._lucilleSkillRNG = Math.floor(Math.random() * 3);"]},{"code":655,"indent":1,"parameters":["if ($gameTemp._lucilleAbsent > 1) {"]},{"code":655,"indent":1,"parameters":["$gameTemp._lucilleSkillRNG = 1;"]},{"code":655,"indent":1,"parameters":["$gameTemp._lucilleAbsent = 0;"]},{"code":655,"indent":1,"parameters":["};"]},{"code":655,"indent":1,"parameters":["};"]},{"code":111,"indent":1,"parameters":[12,"$gameTemp._lucilleSkillRNG == 1"]},{"code":355,"indent":2,"parameters":["var members = $gameParty.aliveMembers();"]},{"code":655,"indent":2,"parameters":["var member = members[0];"]},{"code":655,"indent":2,"parameters":["var skillChoice = 0;"]},{"code":655,"indent":2,"parameters":["switch (ConfigManager.lucilleDifficulty) {"]},{"code":655,"indent":2,"parameters":[" case 0: skillChoice = MacaronaIds.skill[\"Lucille Heal\"] ;break;"]},{"code":655,"indent":2,"parameters":[" case 1: skillChoice = MacaronaIds.skill[\"Lucille Heal (Hard)\"] ;break;"]},{"code":655,"indent":2,"parameters":[" case 2: skillChoice = MacaronaIds.skill[\"Lucille Heal (Challenge)\"] ;break;"]},{"code":655,"indent":2,"parameters":["};"]},{"code":655,"indent":2,"parameters":[""]},{"code":655,"indent":2,"parameters":[""]},{"code":655,"indent":2,"parameters":["member.forceAction(skillChoice, -1);"]},{"code":655,"indent":2,"parameters":["BattleManager.forceAction(member);"]},{"code":655,"indent":2,"parameters":["this.setWaitMode('action');"]},{"code":355,"indent":2,"parameters":["Macarona.ModData.addToData(\"support_count\", 1);"]},{"code":655,"indent":2,"parameters":["if (Macarona.ModData.readData(\"support_count\") > 49) {"]},{"code":655,"indent":2,"parameters":["DGT.UnlockBadge(\"lucilleeverywhere\", \"pink_crutches\");"]},{"code":655,"indent":2,"parameters":["};"]},{"code":355,"indent":2,"parameters":["$gameTemp._lucilleAbsent = 0;"]},{"code":0,"indent":2,"parameters":[]},{"code":411,"indent":1,"parameters":[]},{"code":355,"indent":2,"parameters":["$gameTemp._lucilleAbsent += 1;"]},{"code":0,"indent":2,"parameters":[]},{"code":412,"indent":1,"parameters":[]},{"code":0,"indent":1,"parameters":[]},{"code":412,"indent":0,"parameters":[]},{"code":0,"indent":0,"parameters":[]}],"span":1},{"conditions":{"actorHp":50,"actorId":1,"actorValid":false,"enemyHp":50,"enemyIndex":0,"enemyValid":false,"switchId":3005,"switchValid":false,"turnA":0,"turnB":0,"turnEnding":false,"turnValid":true},"list":[{"code":111,"indent":0,"parameters":[12,"$gameSwitches._lucilleKidnapped"]},{"code":355,"indent":1,"parameters":["$gameTemp._lucilleAbsent = $gameTemp._lucilleAbsent || 0;"]},{"code":355,"indent":1,"parameters":["$gameTemp._lucilleSkillRNG = Math.floor(Math.random() * 5);"]},{"code":111,"indent":1,"parameters":[12,"$gameTemp._lucilleSkillRNG == 1 && ConfigManager.lucilleDifficulty < 2"]},{"code":355,"indent":2,"parameters":["var members = $gameParty.aliveMembers();"]},{"code":655,"indent":2,"parameters":["var member = members[0];"]},{"code":655,"indent":2,"parameters":[""]},{"code":655,"indent":2,"parameters":["member.forceAction(MacaronaIds.skill[\"Starting Shot\"], -1);"]},{"code":655,"indent":2,"parameters":["BattleManager.forceAction(member);"]},{"code":655,"indent":2,"parameters":["this.setWaitMode('action');"]},{"code":355,"indent":2,"parameters":["Macarona.ModData.addToData(\"support_count\", 1);"]},{"code":655,"indent":2,"parameters":["if (Macarona.ModData.readData(\"support_count\") > 49) {"]},{"code":655,"indent":2,"parameters":["DGT.UnlockBadge(\"lucilleeverywhere\", \"pink_crutches\");"]},{"code":655,"indent":2,"parameters":["};"]},{"code":0,"indent":2,"parameters":[]},{"code":411,"indent":1,"parameters":[]},{"code":0,"indent":2,"parameters":[]},{"code":412,"indent":1,"parameters":[]},{"code":0,"indent":1,"parameters":[]},{"code":412,"indent":0,"parameters":[]},{"code":0,"indent":0,"parameters":[]}],"span":0}]}

// This injects the skills and troop pages themself
Macarona.DataManager_isDatabaseLoaded = DataManager.isDatabaseLoaded;
DataManager.isDatabaseLoaded = function () {
  if (!Macarona.DataManager_isDatabaseLoaded.call(this)) return false;
  //this.injectLucilleData();
  this.injectSkill("Lucille Heal", SKILL_LUCILLE_A, 0)
  this.injectSkill("Lucille Heal (Hard)", SKILL_LUCILLE_HARD, 0)
  this.injectSkill("Lucille Heal (Challenge)", SKILL_LUCILLE_CHALLENGE, 0)
  this.injectSkill("Starting Shot", SKILL_LUCILLE_SHOT, 0)
  this.injectLucilleTroopData();
  return true;
};

/**
 * Injects a skill into data skill.
 * @param {*} name The name of the skill associated.
 * @param {*} data The entire JSON-like data of the actual skill. It's ID will be replaced.
 * @param {*} offset The offset from end length of skill list.
 */
DataManager.injectSkill = function (name, data, offset = 0) {
    let skillId = $dataSkills.length + offset;
    MacaronaIds.skill[name] = skillId;
    data.id = skillId;
    $dataSkills.push(data);
    this.extractMetadata($dataSkills[skillId]);
};

// unused
DataManager.injectLucilleData = function () {
    let lucilleSkillId = $dataSkills.length;
    Macarona._lucilleSkillId = lucilleSkillId;
    SKILL_LUCILLE_A.id = lucilleSkillId;
    $dataSkills.push(SKILL_LUCILLE_A);
    this.extractMetadata($dataSkills[lucilleSkillId]);
  };
  
// Adds troop pages to the global troop BEFORE Yanfly's plugin adds it to every other troop in the game.
DataManager.injectLucilleTroopData = function () {
  var base_troop = injectedTroop;
  var troop = $dataTroops[1];
  Macarona.extend(troop.pages, base_troop.pages);
};

//=============================================================================
// * BUFF SYSTEM
//=============================================================================

// ATK:  Buffs: [89, 90, 91]   Debuffs: [92, 93, 94]
// DEF:  Buffs: [95, 96, 97]   Debuffs: [98, 99, 100]
// SPD:  Buffs: [101, 102, 103] Debuffs: [104, 105, 106]
function bajaStateArray(type) {
  switch (type.toLowerCase()) {
    case "atk":
    case "attack":
      return [94, 93, 92, 0, 89, 90, 91];
    case "def":
    case "defense":
      return [100, 99, 98, 0, 95, 96, 97];
    case "spd":
    case "speed":
    case "agi":
      return [106, 105, 104, 0, 101, 102, 103];
    default:
      return [0];
  }
}

Game_Battler.prototype.megatenSlop = function (stat, tier) {
  //if 0 tier then return, it won't do anything lol
  if (tier == 0) {
    return;
  }

  //random emotion and buff generator
  var _type = stat.toLowerCase();

  var arr = bajaStateArray(_type); //Array of State IDs from low to high. 0 is No state.
  var currentState = 0; //current state ID
  var finalState = 0; //final state ID

  //find current state. Tried turning this into function but it doesn't really work lol
  for (const a of arr) {
    if (a !== 0 && this.isStateAffected(a)) {
      currentState = a;
      break;
    }
  }

  //add tier by checking index. Clamp to min max
  const MIN = 0;
  const MAX = arr.length - 1;
  const currentStateIndex = arr.indexOf(currentState); //so it doesnt try to call array multiple times
  finalState = arr[Math.min(Math.max(currentStateIndex + tier, MIN), MAX)];

  //remove old state
  if (finalState != currentState && currentState !== 0)
    this.removeState(currentState);

  //add new state if its not 0, which is no state
  if (finalState != 0) this.addState(finalState);

  SceneManager._scene._statusWindow.refresh();
};
